#define DATAPIN 0
#define ARRSIZ 256

#include <stdio.h>

#ifdef __propeller2__
#include <propeller2.h>
#define CNT _cnt()
#define OUTA _OUTA
#define putbit(pin, val) _pinw(pin, val)
#else
#include <propeller.h>
#define putbit(pin, val) if (val) OUTA |= (1<<pin); else OUTA &= ~(1<<pin);
#endif

int A[ARRSIZ];

void longout(unsigned int value)
{
    int j;
    unsigned int bit;
    for (j = 0; j < 32; j++) {
        bit = value & 1;
        putbit(DATAPIN, bit);
        value = value >> 1;
    }
}

void sendarray()
{
    int i;
    for (i = 0; i < ARRSIZ; i++) {
        longout(A[i]);
    }
}

void main()
{
    int i;
    unsigned int elapsed;

    /* initialize array */
    for (i = 0; i < ARRSIZ; i++) {
        A[i] = i;
    }
    /* now time streaming it out */
    elapsed = CNT;
    sendarray();
    elapsed = CNT - elapsed;
    printf("Elapsed time: %u cycles\n", elapsed);
    for(;;) {
    }
}
